(cl:defpackage :std.concurrency.mailbox
  (:use)
  (:local-nicknames (:% :std.internal)))
(cl:in-package :std.concurrency.mailbox)

(%:fn/macro create (:key name initial-contents) sb-concurrency:make-mailbox)
(%:fn/macro ? (object) sb-concurrency:mailboxp)
(%:fn/macro entries (mailbox) sb-concurrency:list-mailbox-messages)
(%:fn/macro size (mailbox) sb-concurrency:mailbox-count)
(%:fn/macro name ((instance mailbox)) sb-concurrency:mailbox-name)
(%:fn/macro empty? (mailbox) sb-concurrency:mailbox-empty-p)
(%:fn/macro read! (mailbox :key timeout) sb-concurrency:receive-message)
(%:fn/macro read-all! (mailbox :key n) sb-concurrency:receive-pending-messages)
(%:fn/macro read-nonblocking! (mailbox) sb-concurrency:receive-message-no-hang)
(%:fn/macro write! (mailbox message) sb-concurrency:send-message)
